## antimony 0.9.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(Antimony)
set(CMAKE_BUILD_TYPE RELEASE)

set(CMAKE_CXX_FLAGS "-Wall -Wextra -g -Werror=switch")
set(CMAKE_CXX_FLAGS_RELEASE  "-O3 -DRELEASE")
set(CMAKE_CXX_FLAGS_DEBUG    "-O0")

################################################################################

find_package(PythonLibs 3.3 REQUIRED)

if (WIN32)
    add_definitions("-DBOOST_PYTHON_STATIC_LIB")
endif()

if (WIN32)
    find_package(Boost REQUIRED COMPONENTS python3)
elseif (APPLE)
    foreach (PYTHON_NAME python3 python36 python37)
        find_package(Boost QUIET COMPONENTS ${PYTHON_NAME})
        if (${Boost_FOUND})
            break()
        endif()
    endforeach()
elseif (UNIX)
    foreach (PYTHON_NAME python3 python-py36 python-py35 python-py34)
        find_package(Boost QUIET COMPONENTS ${PYTHON_NAME})
        if (${Boost_FOUND})
            break()
        endif()
    endforeach()
endif()

if (NOT ${Boost_FOUND})
    message(FATAL_ERROR "Could not find boost::python3")
endif()

################################################################################

add_subdirectory(lib/graph)
add_subdirectory(lib/fab)

add_subdirectory(app)

=== app/CMakeLists.txt ===
# Instruct CMake to run moc, uic, and rrc automatically when needed.
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

# Make the build directory an include target (for generated moc_ files)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Find the Qt libraries
find_package(Qt5Core REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5OpenGL REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5Concurrent REQUIRED)

set(SRC_FILES
    app/main.cpp
    app/app.cpp
    app/update.cpp
    app/colors.cpp
    canvas/scene.cpp
    canvas/canvas_view.cpp
    canvas/info.cpp
    canvas/inspector/frame.cpp
    canvas/inspector/export.cpp
    canvas/inspector/title.cpp
    canvas/inspector/buttons.cpp
    canvas/inspector/util.cpp
    canvas/datum_row.cpp
    canvas/datum_editor.cpp
    canvas/datum_port.cpp
    canvas/subdatum/subdatum_frame.cpp
    canvas/subdatum/subdatum_editor.cpp
    canvas/subdatum/subdatum_row.cpp
    canvas/connection/base.cpp
    canvas/connection/connection.cpp
    canvas/connection/dummy.cpp
    window/base.cpp
    window/canvas.cpp
    window/viewport.cpp
    window/quad.cpp
    window/base_viewport_window.cpp
    window/script_window.cpp
    graph/constructor/populate.cpp
    graph/proxy/graph.cpp
    graph/proxy/node.cpp
    graph/proxy/script.cpp
    graph/proxy/datum.cpp
    graph/proxy/subdatum.cpp
    graph/proxy/base_datum.cpp
    graph/hooks/hooks.cpp
    graph/hooks/export.cpp
    graph/hooks/ui.cpp
    graph/hooks/title.cpp
    graph/serialize/serializer.cpp
    graph/serialize/deserializer.cpp
    script/syntax.cpp
    script/editor.cpp
    script/frame.cpp
    undo/undo_command.cpp
    undo/undo_add_node.cpp
    undo/undo_add_datum.cpp
    undo/undo_delete_datum.cpp
    undo/undo_delete_multi.cpp
    undo/undo_delete_node.cpp
    undo/undo_delete_link.cpp
    undo/undo_move_node.cpp
    undo/undo_move_datum.cpp
    undo/undo_change_script.cpp
    undo/undo_change_expr.cpp
    undo/undo_stack.cpp
    dialog/exporting.cpp
    dialog/resolution.cpp
    export/export_mesh.cpp
    export/export_heightmap.cpp
    export/export_worker.cpp
    viewport/scene.cpp
    viewport/gl.cpp
    viewport/view.cpp
    viewport/image.cpp
    viewport/control/control.cpp
    viewport/control/control_instance.cpp
    viewport/control/point.cpp
    viewport/control/wireframe.cpp
    viewport/render/instance.cpp
    viewport/render/task.cpp

    gl/gl.qrc
)

set(PY_FAB_FILES
    ../py/fab/__init__.py
    ../py/fab/shapes.py
    ../py/fab/types.py
)

if (APPLE)
    set(ANTIMONY_APP Antimony)
    set(CMAKE_MACOSX_RPATH ON)

    # Add the icon file and deploy it to Resources
    set(SB_ICON ../deploy/mac/sb.icns)
    set_source_files_properties(${SB_ICON}
        PROPERTIES MACOSX_PACKAGE_LOCATION "Resources"
    )

    # Deploy fab module's files into Resources/fab
    set_source_files_properties(${PY_FAB_FILES}
        PROPERTIES MACOSX_PACKAGE_LOCATION "Resources/fab"
    )

    add_executable(${ANTIMONY_APP} MACOSX_BUNDLE
        ${SRC_FILES}
        ${SB_ICON}
        ${PY_FAB_FILES}
    )

    # Set application Info.plist file
    set_target_properties(${ANTIMONY_APP} PROPERTIES
        MACOSX_BUNDLE_INFO_PLIST ../deploy/mac/Info.plist
    )

    # Copy node directory into application bundle
    add_custom_command(TARGET ${ANTIMONY_APP} POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy_directory
            ${CMAKE_SOURCE_DIR}/py/nodes
            ${CMAKE_CURRENT_BINARY_DIR}/${ANTIMONY_APP}.app/Contents/Resources/nodes)
else()
    set(ANTIMONY_APP antimony)
    add_executable(${ANTIMONY_APP} ${SRC_FILES})

    # Copy node and fab directory into build directory
    add_custom_command(TARGET ${ANTIMONY_APP} POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy_directory
            ${CMAKE_SOURCE_DIR}/py/nodes
            ${CMAKE_CURRENT_BINARY_DIR}/sb/nodes)
    add_custom_command(TARGET ${ANTIMONY_APP} POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy_directory
            ${CMAKE_SOURCE_DIR}/py/fab
            ${CMAKE_CURRENT_BINARY_DIR}/sb/fab)

    install(TARGETS antimony
            DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
    install(DIRECTORY ../py/nodes
            DESTINATION ${CMAKE_INSTALL_PREFIX}/share/antimony)
    install(DIRECTORY ../py/fab
            DESTINATION ${CMAKE_INSTALL_PREFIX}/share/antimony)
endif()

target_link_libraries(${ANTIMONY_APP}
    Qt5::Widgets
    Qt5::Gui
    Qt5::OpenGL
    Qt5::Network
    Qt5::Concurrent
    SbGraph
    SbFab)

################################################################################

execute_process(COMMAND git log --pretty=format:'%h' -n 1
                OUTPUT_VARIABLE GITREV)
execute_process(COMMAND bash -c "git diff --quiet --exit-code || echo +"
                OUTPUT_VARIABLE GITDIFF)
execute_process(COMMAND git describe --exact-match --tags
                OUTPUT_VARIABLE GITTAG
                ERROR_QUIET)
execute_process(COMMAND git rev-parse --abbrev-ref HEAD
                OUTPUT_VARIABLE GITBRANCH)

add_definitions(-D'GITREV="${GITREV}${GITDIFF}"'
                -D'GITTAG="${GITTAG}"'
                -D'GITBRANCH="${GITBRANCH}"')

################################################################################

target_include_directories(${ANTIMONY_APP} SYSTEM PRIVATE
    ${PYTHON_INCLUDE_DIRS}
    ${Boost_INCLUDE_DIRS}
    ${AUTOGEN_TARGETS_FOLDER}
)

################################################################################

set_property(TARGET ${ANTIMONY_APP} PROPERTY CXX_STANDARD 11)
set_property(TARGET ${ANTIMONY_APP} PROPERTY C_STANDARD 99)

=== lib/fab/CMakeLists.txt ===
find_package(PNG REQUIRED)
find_package(FLEX REQUIRED)

################################################################################

# Custom command to generate the parser sources with lemon
if(WIN32)
    find_program(LEMON_EXECUTABLE lemon.exe DOC "path to the lemon executable")
else()
    find_program(LEMON_EXECUTABLE lemon DOC "path to the lemon executable")
endif()

mark_as_advanced(LEMON_EXECUTABLE)
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/v2syntax.lemon.hpp
           ${CMAKE_CURRENT_BINARY_DIR}/v2syntax.lemon.cpp
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/src/tree/v2syntax.y
    COMMAND ${LEMON_EXECUTABLE} -q -c -s ${CMAKE_CURRENT_SOURCE_DIR}/src/tree/v2syntax.y
    COMMAND mv ${CMAKE_CURRENT_SOURCE_DIR}/src/tree/v2syntax.c ${CMAKE_CURRENT_BINARY_DIR}/v2syntax.lemon.cpp
    COMMAND mv ${CMAKE_CURRENT_SOURCE_DIR}/src/tree/v2syntax.h ${CMAKE_CURRENT_BINARY_DIR}/v2syntax.lemon.hpp)

# Custom command to generate the lexer sources with flex
if(WIN32)
    find_program(FLEX_EXECUTABLE flex.exe DOC "path to the flex executable")
else()
    find_program(FLEX_EXECUTABLE flex DOC "path to the flex executable")
endif()
mark_as_advanced(FLEX_EXECUTABLE)
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/v2syntax.yy.hpp
           ${CMAKE_CURRENT_BINARY_DIR}/v2syntax.yy.cpp
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/src/tree/v2syntax.l
    COMMAND ${FLEX_EXECUTABLE} --outfile=${CMAKE_CURRENT_BINARY_DIR}/v2syntax.yy.cpp
                               --header-file=${CMAKE_CURRENT_BINARY_DIR}/v2syntax.yy.hpp
                               ${CMAKE_CURRENT_SOURCE_DIR}/src/tree/v2syntax.l)

add_library(SbFab STATIC
    src/fab.cpp
    src/formats/png.c
    src/formats/stl.c
    src/tree/eval.c
    src/tree/math/math_f.c
    src/tree/math/math_g.c
    src/tree/math/math_i.c
    src/tree/math/math_r.c
    src/tree/node/node_c.c
    src/tree/node/opcodes.c
    src/tree/node/printers.c
    src/tree/node/printers_ss.cpp
    src/tree/node/results.c
    src/tree/parser.c
    src/tree/render.c
    src/tree/tree.c
    src/tree/v2parser.cpp
    src/tree/triangulate/mesher.cpp
    src/tree/triangulate/triangle.cpp
    src/tree/triangulate.cpp
    src/types/bounds.cpp
    src/types/shape.cpp
    src/types/transform.cpp
    src/util/region.c
    src/util/ustack.c

    # Generated files
    ${CMAKE_CURRENT_BINARY_DIR}/v2syntax.lemon.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/v2syntax.yy.cpp
)

target_include_directories(SbFab SYSTEM PRIVATE
    ${PYTHON_INCLUDE_DIRS}
    ${Boost_INCLUDE_DIRS}
    ${PNG_INCLUDE_DIR}
)

# Add the binary dir to include generated files
target_include_directories(SbFab PRIVATE
    ${CMAKE_CURRENT_BINARY_DIR}
)

target_link_libraries(SbFab
    ${Boost_LIBRARIES}
    ${PYTHON_LIBRARY}
    ${PNG_LIBRARIES}
)
target_include_directories(SbFab PUBLIC inc)
target_include_directories(SbFab SYSTEM PRIVATE
    vendor)

################################################################################

add_executable(SbFabTest
    tests/main.cpp
    tests/parser.cpp
    tests/shape.cpp
)
target_link_libraries(SbFabTest SbFab)

target_include_directories(SbFabTest SYSTEM PRIVATE
    ../../vendor
    ${Boost_INCLUDE_DIRS}
    ${PYTHON_INCLUDE_DIRS}
)

################################################################################

set_property(TARGET SbFab PROPERTY CXX_STANDARD 11)
set_property(TARGET SbFab PROPERTY C_STANDARD 99)
set_property(TARGET SbFabTest PROPERTY CXX_STANDARD 11)
set_property(TARGET SbFabTest PROPERTY C_STANDARD 99)

=== lib/fab/vendor/Eigen/src/Eigenvalues/CMakeLists.txt ===
FILE(GLOB Eigen_EIGENVALUES_SRCS "*.h")

INSTALL(FILES
  ${Eigen_EIGENVALUES_SRCS}
  DESTINATION ${INCLUDE_INSTALL_DIR}/Eigen/src/Eigenvalues COMPONENT Devel
  )

=== lib/fab/vendor/Eigen/src/Householder/CMakeLists.txt ===
FILE(GLOB Eigen_Householder_SRCS "*.h")

INSTALL(FILES
  ${Eigen_Householder_SRCS}
  DESTINATION ${INCLUDE_INSTALL_DIR}/Eigen/src/Householder COMPONENT Devel
  )

=== lib/fab/vendor/Eigen/src/IterativeLinearSolvers/CMakeLists.txt ===
FILE(GLOB Eigen_IterativeLinearSolvers_SRCS "*.h")

INSTALL(FILES
  ${Eigen_IterativeLinearSolvers_SRCS}
  DESTINATION ${INCLUDE_INSTALL_DIR}/Eigen/src/IterativeLinearSolvers COMPONENT Devel
  )

=== lib/fab/vendor/Eigen/src/PardisoSupport/CMakeLists.txt ===
FILE(GLOB Eigen_PardisoSupport_SRCS "*.h")

INSTALL(FILES 
  ${Eigen_PardisoSupport_SRCS}
  DESTINATION ${INCLUDE_INSTALL_DIR}/Eigen/src/PardisoSupport COMPONENT Devel
  )

=== lib/fab/vendor/Eigen/src/SparseCore/CMakeLists.txt ===
FILE(GLOB Eigen_SparseCore_SRCS "*.h")

INSTALL(FILES 
  ${Eigen_SparseCore_SRCS}
  DESTINATION ${INCLUDE_INSTALL_DIR}/Eigen/src/SparseCore COMPONENT Devel
  )

=== lib/fab/vendor/Eigen/src/StlSupport/CMakeLists.txt ===
FILE(GLOB Eigen_StlSupport_SRCS "*.h")

INSTALL(FILES
  ${Eigen_StlSupport_SRCS}
  DESTINATION ${INCLUDE_INSTALL_DIR}/Eigen/src/StlSupport COMPONENT Devel
  )

=== debian/changelog ===
antimony (0.9.3-2build9) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:15:31 +1100

antimony (0.9.3-2build8) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 03:51:44 +0000

antimony (0.9.3-2build7) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 06:01:38 +0000

antimony (0.9.3-2build6) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 19 Jan 2024 18:55:16 +0000

antimony (0.9.3-2build5) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:45:37 +0100

antimony (0.9.3-2build4) lunar; urgency=medium

  * No-change rebuild with Python 3.11 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 25 Dec 2022 19:32:57 +0000

antimony (0.9.3-2build3) kinetic; urgency=medium

  * No-change rebuild to pick up fixed libboost-python dependencies

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 03 Sep 2022 12:02:57 +0000

antimony (0.9.3-2build2) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Jan 2022 19:01:05 +0000

antimony (0.9.3-2build1) hirsute; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 12 Dec 2020 13:02:51 +0100

antimony (0.9.3-2) unstable; urgency=medium

  * Add patch to import QPainterPath. Thanks to Tobias Frost. Closes: #975109

 -- Tiago Bortoletto Vaz <tiago@debian.org>  Fri, 20 Nov 2020 09:45:45 -0500

antimony (0.9.3-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Add 0003-Change-python-variable-in-cmake.patch closes: #951979

 -- Håvard Flaget Aasen <haavard_aasen@yahoo.no>  Mon, 30 Mar 2020 18:27:18 +0200

antimony (0.9.3-1.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Ondřej Nový ]
  * d/control: Set Vcs-* to salsa.debian.org

  [ Tiago Bortoletto Vaz ]
  * Add MPL-2.0 notice to debian/copyright.
  * Add Boost license notice to debian/copyright.

  [ Håvard Flaget Aasen ]
  * Explicit build-dependency on dh-python. closes: #947326
  * Use new CMake discovery for python and boost::python. closes: #947479
    - Patch from Ubuntu.
  * This package embeds python3, and is only built against the default
    version. Change build-dependency to python3-dev.
    - Patch from Ubuntu.
  * Remove duplicated header in debian/copyright

 -- Håvard Flaget Aasen <haavard_aasen@yahoo.no>  Mon, 06 Jan 2020 10:39:41 +0100

antimony (0.9.3-1) unstable; urgency=low

  * Initial packaging. Based on Peter Felecan <peter@felecan.org> package work
    from upstream repository. (Closes: #907435)

 -- Tiago Bortoletto Vaz <tiago@debian.org>  Mon, 27 Aug 2018 19:20:45 -0400

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@ --with python3 --buildsystem=cmake

override_dh_strip:
	dh_strip --automatic-dbgsym

## antimony 0.9.3+qtbuild

=== lib/graph/CMakeLists.txt ===
add_library(SbGraph STATIC
    src/datum.cpp
    src/graph.cpp
    src/node.cpp
    src/script_node.cpp
    src/graph_node.cpp
    src/proxy.cpp
    src/script.cpp
    src/util.cpp
    src/types/downstream.cpp
    src/types/root.cpp
    src/hooks/hooks.cpp
    src/hooks/input.cpp
    src/hooks/output.cpp
)

target_include_directories(SbGraph SYSTEM PRIVATE
    ${PYTHON_INCLUDE_DIRS}
    ${Boost_INCLUDE_DIRS}
)
target_link_libraries(SbGraph
    ${Boost_LIBRARIES}
    ${PYTHON_LIBRARY}
)
target_include_directories(SbGraph PUBLIC inc)

################################################################################

add_executable(SbGraphTest
    tests/datum.cpp
    tests/graph.cpp
    tests/link.cpp
    tests/main.cpp
    tests/node.cpp
    tests/script.cpp
    tests/subgraph.cpp
)
target_link_libraries(SbGraphTest SbGraph)

target_include_directories(SbGraphTest SYSTEM PRIVATE
    ${PYTHON_INCLUDE_DIRS}
    ${Boost_INCLUDE_DIRS}
    ../../vendor
)

################################################################################

set_property(TARGET SbGraph PROPERTY CXX_STANDARD 11)
set_property(TARGET SbGraph PROPERTY C_STANDARD 99)
set_property(TARGET SbGraphTest PROPERTY CXX_STANDARD 11)
set_property(TARGET SbGraphTest PROPERTY C_STANDARD 99)

=== lib/fab/vendor/Eigen/src/CholmodSupport/CMakeLists.txt ===
FILE(GLOB Eigen_CholmodSupport_SRCS "*.h")

INSTALL(FILES 
  ${Eigen_CholmodSupport_SRCS}
  DESTINATION ${INCLUDE_INSTALL_DIR}/Eigen/src/CholmodSupport COMPONENT Devel
  )

=== debian/changelog ===
antimony (0.9.3+qtbuild-1+eagle) unstable; urgency=medium

  * update

 -- Tiago Bortoletto Vaz <tiago@debian.org>  Tue, 26 Jan 2021 20:51:20 +0800

=== debian/control ===
Source: antimony
Section: graphics
Priority: optional
Vcs-Browser: https://salsa.debian.org/debian/antimony
Vcs-Git: https://salsa.debian.org/debian/antimony.git
Maintainer: Tiago Bortoletto Vaz <tiago@debian.org>
Build-Depends: debhelper (>= 9),
 libpng-dev,
 python3-all-dev,
 libboost-all-dev,
 libgl1-mesa-dev,
 lemon,
 flex,
 ninja-build,
 qtbase5-dev,
 libqt5opengl5-dev,
 cmake,
 desktop-file-utils,
 zlib1g-dev
Standards-Version: 4.2.0

Package: antimony
Architecture: any
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: Computer-aided design CAD tool
 Antimony is a computer-aided design (CAD) tool from a
 parallel universe in which CAD software evolved
 from Lisp machines rather than drafting tables.
 .
 Antimony provides the Python3 Fab that is
 a set of software tools for personal fabrication,
 intended for use with machines common to fab labs.
 For info about Fab visit kokompe.cba.mit.edu/.
